public class CopyOnWriteArrayList<T>
  implements Iterable<T> {
  // ̂߂
  private volatile Object[] array = new Object[0];

  // Rs[EIECgŗvfǉ
  public synchronized void add(T element) {
    Object[] elements = array;
    int len = elements.length;
    Object[] newElements = Arrays.copyOf(elements,
      len + 1);
    newElements[len] = element;
    array = newElements;
  }

  public synchronized E set(int index, E element) {
  // 
  }

  public T get(int index) {
    return (T) array[index];
  }

  public int size() {
    return array.length;
  }

  public boolean isEmpty() {
    return size() == 0;
  }

  @Override
  public Iterator<T> iterator() {
    return new COWIterator<T>(array);
  }

  private static class COWIterator<E>
    implements ListIterator<E> {
    private final Object[] snapshot;
    private int cursor = 0;

    COWIterator(Object[] snapshot){
      this.snapshot = snapshot;
    }

    @Override
    public boolean hasNext() {
      return cursor < snapshot.length;
    }

    @Override
    @SuppressWarnings("unchecked")
    public E next() {
      try {
        return (E) snapshot[cursor++];
      } catch (IndexOutOfBoundsException ex) {
        throw new NoSuchElementException();
      }
    }

    @Override
    public void remove() {
      throw new UnsupportedOperationException();
    }
    // 
  }
}