public class Person {
  private final List<Address> addresses =
    new ArrayList<Address>();
  private final List<PhoneNumber> phoneNumbers =
    new ArrayList<PhoneNumber>();

  public List<Address> findByPref(Pref pref){
    synchronized(addresses){
      List<Address> result = new ArrayList<Address>();
      for(Address address : addresses) {
        if (address.getPref().equals(pref)) {
          result.add(address);
        }
        return result;
      }
    }
  }

  public PhoneNumber findByMainNumber() {
    synchronized(phoneNumbers) {
      for(PhoneNumber phoneNumber : phoneNumbers) {
        if (phoneNumber.isMainNumber()) {
          return phoneNumber;
        }
      }
      return null;
    }
  }
}